%{!?python2_sitearch: %global python2_sitearch %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

%global __provides_exclude_from ^%{python2_sitearch}/.*\\.so$

%global upstream_name gevent

Name:           python-%{upstream_name}102
Version:        1.0.2
Release:        2%{?dist}
Summary:        A coroutine-based Python networking library

Group:          Development/Languages
License:        MIT
URL:            https://www.gevent.org/
Source0:        https://pypi.python.org/packages/source/g/gevent/gevent-%{version}.tar.gz

# gevent requires greenlet >= 0.4.7 but we have 0.4.5 in Fedora.
# The version requirement is only related to Python 2.5 support
# so we are fine with any version.
Patch2:         0002-remove-version-requirement-for-greenlet.patch

# Some distribution have backported most of PEP 466.
Patch3:         0003-allow-backported-pep466.patch

BuildRequires:  python2-devel
BuildRequires:  c-ares-devel
BuildRequires:  libev-devel
Requires:       python-greenlet

%description
gevent is a coroutine-based Python networking library that uses greenlet to
provide a high-level synchronous API on top of libevent event loop.

Features include:

  * convenient API around greenlets
  * familiar synchronization primitives (gevent.event, gevent.queue)
  * socket module that cooperates
  * WSGI server on top of libevent-http
  * DNS requests done through libevent-dns
  * monkey patching utility to get pure Python modules to cooperate

%prep
%setup -q -n %{upstream_name}-%{version}
# Remove bundled libraries
rm -r c-ares libev
%patch2 -p1
%patch3 -p1

%build
CFLAGS="%{optflags} -I%{_includedir}/libev" %{__python2} setup.py build

%install
%{__python2} setup.py install -O1 --skip-build --root %{buildroot}
# Fix non-standard-executable-perm error
%{__chmod} 0755 %{buildroot}%{python2_sitearch}/%{upstream_name}/core.so

%files
%doc LICENSE README.rst
%{python2_sitearch}/%{upstream_name}
%{python2_sitearch}/%{upstream_name}-%{version}-*.egg-info

%changelog
* Mon Mar 04 2019 Martin Styk <mastyk@redhat.com> - 1.0.2-2
- Allow backported PEP466

* Mon Mar 04 2019 Martin Styk <mastyk@redhat.com> - 1.0.2-1
- Initial build
